# STA RTOS Utilities

![pre-release v1.0.0](https://img.shields.io/static/v1?label=pre-release&message=v1.0.0&color=orange&logo=git)
![Standard: C++11](https://img.shields.io/static/v1?label=standard&message=C%2B%2B11&color=blue&logo=cplusplus)

Library providing the software stack for use with the ALPAKA hardware design for RTOS projects.

Modules can be configured via defines set in `<sta/config.hpp>` header file which must be provided by the application.


# ALPAKA Modules

All enabled modules are initialized by calling the `startALPAKA` function from the default task.

The function `startupExtras` is called before any module initialization and can be used by the application
to execute additional initialization steps before any task waiting for the startup system event will run.
The function prototype can be found in the `<sta/rtos/startup.hpp>` header and can optionally be implemented
anywhere in the application code.


## Can Bus

TODO Add description

Configuration:


## Watchdog

The watchdog task waits for signals sent either from its heartbeat timer or manually via `sta::notifyWatchdog`
and passes the event flags to the `sta::watchdogEventHandler` function. This function must be implemented by the application.

Configuration:
* `#define STA_RTOS_WATCHDOG_ENABLE`: Enable module
* `#define STA_RTOS_WATCHDOG_TIMER_PERIOD <period_ticks>`: Set period in ticks of heartbeat timer (default: 1000)


# STA-Core Interfaces

The library provides implementations for the following interfaces using CMSIS-RTOS2 functionality:
* `Mutex`
* `Signal`
